let currentPattern = 1; // Variable to track selected pattern
let angle = 0; // Variable for oscillation motion
let offset = 0; // Variable to create pulse effect

function setup() {
    createCanvas(500, 500);
    noLoop(); // Ensures draw() runs only once when initial setup is done
}

function draw() {
    background(0); // Clear the background each frame
    offset = sin(angle) * 15; // Calculate the offset for pulsation
    angle += 0.05; // Increment angle for oscillating effect

    for (let x = 25; x < width; x += 50) {
        for (let y = 25; y < height; y += 50) {
            switch (currentPattern) {
                case 1:
                    pulsatingCircles(x + offset, y + offset); // Pulsating effect on circles
                    break;
                case 2:
                    movingGridLines(x + offset, y + offset); // Moving grid with offset
                    break;
            }
        }
    }
}

// Function to draw pulsating circles
function pulsatingCircles(xVal, yVal) {
    fill(random(255), random(255), random(255));  // Random fill color
    let radius = 30 + sin(angle) * 10; // Calculate pulsating radius
    ellipse(xVal, yVal, radius, radius); // Draw circle
}

// Function to draw moving grid lines
function movingGridLines(xVal, yVal) {
    stroke(random(255), random(255), random(255)); // Random chance for color
    strokeWeight(2);
    line(xVal - 25, yVal, xVal + 25, yVal); // Horizontal line
    line(xVal, yVal - 25, xVal, yVal + 25); // Vertical line
}

// Capture key presses to change pattern
function keyPressed() {
    if (key >= '1' && key <= '2') {
        currentPattern = int(key); // Switch pattern based on key pressed
        redraw(); // Redraw with the new pattern
    }
}